    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * ----------------
    028     * DomainOrder.java
    029     * ----------------
    030     * (C) Copyright 2004-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 29-Jul-2004 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.data;
    042
    043    import java.io.ObjectStreamException;
    044    import java.io.Serializable;
    045
    046    /**
    047     * Used to indicate sorting order if any (ascending, descending or none).
    048     */
    049    public final class DomainOrder implements Serializable {
    050
    051        /** For serialization. */
    052        private static final long serialVersionUID = 4902774943512072627L;
    053
    054        /** No order. */
    055        public static final DomainOrder NONE = new DomainOrder("DomainOrder.NONE");
    056
    057        /** Ascending order. */
    058        public static final DomainOrder ASCENDING
    059            = new DomainOrder("DomainOrder.ASCENDING");
    060
    061        /** Descending order. */
    062        public static final DomainOrder DESCENDING
    063            = new DomainOrder("DomainOrder.DESCENDING");
    064
    065        /** The name. */
    066        private String name;
    067
    068        /**
    069         * Private constructor.
    070         *
    071         * @param name  the name.
    072         */
    073        private DomainOrder(String name) {
    074            this.name = name;
    075        }
    076
    077        /**
    078         * Returns a string representing the object.
    079         *
    080         * @return The string.
    081         */
    082        public String toString() {
    083            return this.name;
    084        }
    085
    086        /**
    087         * Returns <code>true</code> if this object is equal to the specified
    088         * object, and <code>false</code> otherwise.
    089         *
    090         * @param obj  the other object.
    091         *
    092         * @return A boolean.
    093         */
    094        public boolean equals(Object obj) {
    095
    096            if (this == obj) {
    097                return true;
    098            }
    099            if (!(obj instanceof DomainOrder)) {
    100                return false;
    101            }
    102            DomainOrder that = (DomainOrder) obj;
    103            if (!this.name.equals(that.toString())) {
    104                return false;
    105            }
    106            return true;
    107        }
    108
    109        /**
    110         * Returns a hash code value for the object.
    111         *
    112         * @return The hashcode
    113         */
    114        public int hashCode() {
    115            return this.name.hashCode();
    116        }
    117
    118        /**
    119         * Ensures that serialization returns the unique instances.
    120         *
    121         * @return The object.
    122         *
    123         * @throws ObjectStreamException if there is a problem.
    124         */
    125        private Object readResolve() throws ObjectStreamException {
    126            if (this.equals(DomainOrder.ASCENDING)) {
    127                return DomainOrder.ASCENDING;
    128            }
    129            else if (this.equals(DomainOrder.DESCENDING)) {
    130                return DomainOrder.DESCENDING;
    131            }
    132            else if (this.equals(DomainOrder.NONE)) {
    133                return DomainOrder.NONE;
    134            }
    135            return null;
    136        }
    137
    138    }